<?php
/**
 * File Name:    commtouch.php
 * Description:  Commtouch Configuration read and write values and validation functions.
 * Created By:   Surya
 * Created Date:  26/12/2011
 * Change Log:   V 1.0 - Initial Version
 *
 * Function List
 * 1.  commtouch_getemplates() 	 		# Define template variables
 * 2.  print_form()				 		# Passing variables to form
 * 3.  commtouch_successmessage() 	 	# Return success message depending on apply or submit button
 * 4.  fread_stream()				 		# Read  the file and return values from file.
 * 5.  get_ctasd_value()			 		# Read  the file and return values from ctasd-out.conf
 * 6.  commtouch_license()			 	# Returning Server configuration tab licence key
 * 7.  commtouch_serveraddress()	 		# Returning Server configuration tab server address
 * 8.  commtouch_outboundfiltering() 		# Returning Server configuration tab Out bound filtering value
 * 9.  commtouch_bypassonerror()	 		# Returning Server configuration tab Bypassonerror value
 * 10. commtouch_smtpauth()		 		# Returning Senderid definitions tab Smtp auth value
 * 11. commtouch_senderip()				# Returning Senderid definitions tab Senderip value
 * 12. commtouch_senderidheadername()		# Returning Senderid definitions tab Customer header value
 * 13. commtouch_senderidcollectionpath()	# Returning Senderid definitions tab Sample Collection value
 * 14. commtouch_spamthreshold()			# Returning Senderid definitions tab Total Spam threshold value
 * 15. commtouch_suspectthreshold()		# Returning Senderid definitions tab Total Suspect threshold value
 * 16. commtouch_virusthreshold()		    # Returning Senderid definitions tab Total Virus threshold value
 * 17. commtouch_confirmspam()		    # Returning Policies tab Total Confirmed spam value
 * 18. commtouch_bulkspam()		    	# Returning Policies tab Bulk spam value
 * 19. commtouch_virus()					# Returning Policies tab Virus value
 * 20. commtouch_highrisk()				# Returning Policies tab High Risk value
 * 21. commtouch_totalspam()				# Returning Policies tab Total Spam value
 * 22. commtouch_totalspamaction()		# Returning Policies tab Total Spam Action value
 * 23. commtouch_totalsuspected()			# Returning Policies tab Total Suspected value
 * 24. commtouch_totalsuspectedaction()	# Returning Policies tab Total Suspected Action value
 * 25. commtouch_totalvirus()				# Returning Policies tab Total Virus value
 * 26. commtouch_totalvirusaction()		# Returning Policies tab Total Virus Action value
 * 27. commtouch_totalmsgs()				# Returning Policies tab Total messages value
 * 28. commtouch_totalmsgsaction()		# Returning Policies tab Total messages Action value
 * 29. commtouch_whitelist()				# Returning Whitelist tab whitelist value
 * 30. commtouch_whitelist()				# Returning Bluelist tab bluelist value
 * 31. trim_value()						# Returns post values with trim function
 * 32. set_permission() 					# Set the file permission using wrapper
 * 32. fwrite_stream() 					# Write the values into file ctasd-out.conf and returns response
 * 33. fwrite_stream1()					# Write the values into file and returns response
 * 34. valid_filepath ()                  # Validate file path
 * 35.validate_server()					# Validate server address
 * 36.validate_custom()					# Validate Ascii code
 * 37. fwrite_stream_list()             # for writing bluelist and whitelist data to files
 * 38. fwrite_stream_headername()       # for writing SenderIDHeaderName to ctasd-out.conf file
 * 39 fwrite_xml()						# for Writing to xml file
 * 40 init_graph()						# Initializing dashboard graph
 */
//------------------------------Start Common functions-----------------------
//$ctasdmailtype 		= 		mail_type();
//$ctasdmailtype 							= 			"QMail";  //Postfix  QMail
function commtouch_getemplates($file_tpl)
{
	$templates = array();
	$templates = array (
		        'main'  =>      'main.tpl',
		        'tab'   =>      'modules/'.MODULE_NAME.'/'.$file_tpl.'.tpl',
	);
	return $templates;
}
function print_form( $vars, $templates, $template) {
	$form = new pm_Form;
	$form->addTemplates($templates);
	$form->define();
	$form->addVars($vars);
	$form->assign();
	foreach ($vars as $key => $var) {
		$form->parse( 'INFO', $template);
	}
	$form->define_dynamic( 'tab', 'BODY');
	$form->parse( 'BODY', 'tab');
	$form->parse( 'DOCUMENT', 'main');
	$form->FastPrint();
}
function commtouch_successmessage()
{
	if($_GET['msg']==1)
	{
		$msg												= 			"Configuration saved and restarted Commtouch service";
		$msg1= $msg;
		$msg='<div class="msg-box msg-info"><div class="msg-content"><span class="title">'.$msg.' </span></div></div>';
	}
	elseif($_GET['msg']==2)
	{
		$msg												= 			"Configuration saved successfully , Click the Apply button to restart the Commtouch service.";
		$msg1= $msg;
		$msg='<div class="msg-box msg-info"><div class="msg-content"><span class="title">'.$msg.' </span></div></div>';
	}
	else
	{
		$msg												= 			"";
	}
	return $msg;
}

function mail_type() // Getting mail type(Qmail or Postfix)
{
	$justback = exec(PRODUCT_ROOT."/admin/bin/modules/".MODULE_NAME."/ctasd_mail");
	return $justback;
}
function enableoutboundfiltering($var) // Updating Enable out bound filtering
{
	$justback = exec(PRODUCT_ROOT."/admin/bin/modules/".MODULE_NAME."/postoutset ".$var);
	return $justback;
}

//------------------------------End Common functions-------------------------
// --------------------- Start reading values ---------------------------------
//----- Get values from function -----------------
function fread_stream($fp, $fn)
{
	$filepath									=			$fp.$fn;
	if (file_exists($filepath)) {
		$fh                                		= 			trim(file_get_contents($filepath));
	} else {
		$fh                                		= 			"";
	}

	return $fh;
}
// Postfix return value based on value
function getenvalfun($val)
{
	$postfixvar 								=   		"/opt/ctch/ct-milter/";
	$postconffile								=			"ct-milter.args";
	$splitcontents  = postfixfileread($postfixvar,$postconffile);
	$rows = explode(" ", $splitcontents);
	foreach ($rows as $value) {
		if($value==$val)
		{
			return 1;
		}
	}
}
function getenvalctmilterfun($val)
{
	$postfixvar 								=   		"/opt/ctch/ct-milter/";
	$postconffile								=			"ct-milter.args";
	$splitcontents  = postfixfileread($postfixvar,$postconffile);
	$rows = explode(" ", $splitcontents);
	foreach ($rows as $value) {
		if($value==$val)
		{
			return 1;
		}
	}
}
// Postfix returning value based on value and space
function getereadnvalfun($val)
{
	$postfixvar 								=   		"/opt/ctch/ct-milter/";
	$postconffile								=			"ct-milter.args";
	$splitcontents  = postfixfileread($postfixvar,$postconffile);
	$rows = explode(" ", $splitcontents);
	foreach ($rows as $value) {
		if($value==$val)
		{
			$i = 34;
		}
		if($i==35)
		{
			return $value;
		}
		$i++;
		}
}
function get_value_ofcat($name)
{
	$postfixvar1 								=   		"/opt/ctch/ct-milter/";
	$postconffile1								=			"ct-milter.args";
	$filepath 									= 			$postfixvar1.$postconffile1;
	$lines = file($filepath);
	foreach (array_values($lines) AS $line)
	{
		list($key, $val) = explode('=', trim($line) );
		if (trim($key) == $name)
		{
			return $val;
		}
	}
	return false;
}
function fread_main_stream($fp, $fn)
{
	$filepath									=			$fp.$fn;
	set_permission($filepath,"1");
	$fh 										= 			fopen($filepath, 'r') or die("can't open ".$filepath." file");
	while (!feof($fh))
	{
			
		$contents .=fgets($fh);
		$contents .=',';

	}
	// Echo the files contents
	fclose($fh);
	set_permission($filepath,"0");
	return $contents;
}
function get_ctasd_value($search_key)
{
	$ctsdconfpath						=			"/etc/ctasd/";
	$ctsdconffile						=			"ctasd-out.conf";
	$filepath		=		$ctsdconfpath.$ctsdconffile;

	set_permission($filepath,"1");
	if(!$file_array			= 	file($filepath))
	return 0;
	if(count($file_array)<=0)
	return "empty file";
	$found=0;
	foreach($file_array as $line)
	{
		if (strstr($line,$search_key)&& strstr($line,"#")== false)
		{
		 $found=1;
			$find= $line;
			break;
		}
	}
	set_permission($filepath,"0");
	if($found)
	return trim(str_replace($search_key." =","",$find));
	else
	return "";
}
/*  Server Configuration tab functions  */

// Post fix read values
function postfixfileread($fp,$fn) {
    $filename = $fp.$fn;
    if (!file_exists($filename))
	return "";
    $fd = fopen ($filename, "r");
    $contents = file_get_contents($filename);
    return $contents;
}

// License Key
function commtouch_license()
{
	$licensekeyvalue							=			get_ctasd_value("License_key_code");
	return  $licensekeyvalue;
}
// Server Address
function commtouch_serveraddress()
{
	$serveraddressvalue							=			get_ctasd_value("Server_address");
	if($serveraddressvalue  ==  "")
	{
		$serveraddressvalue						= 			"resolver%d.plesk.ctmail.com";
	}
	else
	{
		$serveraddressvalue						= 			get_ctasd_value("Server_address");
	}
	return $serveraddressvalue;
}
// Outbound Filtering
function commtouch_outboundfiltering()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$outboundfiltering						=  			fread_stream('/var/qmail/control/','ctasd_check_outbound');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$outboundfiltering						=  			enableoutboundfiltering('check');
	}
	if($outboundfiltering 	==	"1")
	{
		$outboundfiltering						=			"checked";
	}
	else
	{
		$outboundfiltering						=			"";
	}
	return $outboundfiltering;
}
//Bypass on Error
function commtouch_bypassonerror()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$bypassonerrors								=  			fread_stream('/var/qmail/control/','ctasd_require_scan');
		if($bypassonerrors		==	"0")
	{
		$bypassonerrors							=			"checked";
	}
	else
	{

		$bypassonerrors							=			"";
	}
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$bypassonerrors								=  			getenvalfun('-T');
		if($bypassonerrors		==	"1")
	{
		$bypassonerrors							=			"checked";
	}
	else
	{

		$bypassonerrors							=			"";
	}
	}
	
	return $bypassonerrors;
}
/*  Sender id tab functions  */

// Sender Id SMTP authentication
function commtouch_smtpauth()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$smtpauth									=			fread_stream('/var/qmail/control/','ctasd_senderid_smtpauth');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$smtpauth									=  			getenvalfun('-a');
	}
	return $smtpauth;
}
// Sender Id Sender IP
function commtouch_senderip()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$senderip									=			fread_stream('/var/qmail/control/','ctasd_senderid_senderip');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$senderip									=  			getenvalfun('-e');
	}
	return $senderip;
}
// Sender Id header name
function commtouch_senderidheadername()
{
	$senderidheadername							=			trim(get_ctasd_value("SenderIDHeaderName"));
	return $senderidheadername;
}
// Sender Id header name
function commtouch_senderidcollectionpath()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$senderidcollectionpath						=			fread_stream('/var/qmail/control/','ctasd_report_imap_folder');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$senderidcollectionpath						=  			getereadnvalfun('-D');
	}
	return $senderidcollectionpath;
}
// Sender Id Spamthershold
function commtouch_spamthreshold()
{
	$senderidspamthreshold						=			get_ctasd_value("SpamThreshold1");
	return $senderidspamthreshold;
}
// Sender Id Suspectthershold
function commtouch_suspectthreshold()
{
	$senderidsuspectthreshold					=			get_ctasd_value("SuspectedThreshold1");
	return $senderidsuspectthreshold;
}
// Sender Id Spamthershold
function commtouch_virusthreshold()
{
	$senderidvirusthreshold						=			get_ctasd_value("VirusThreshold1");
	return $senderidvirusthreshold;
}
/*  Policies tab functions  */

// Confirmed Spam
function commtouch_confirmspam()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$spamvalue									=  			fread_stream('/var/qmail/control/','ctasd_onsession_out_block_spam');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$spamvalue									=  			getenvalfun('--outbound-spam-reject');
	}
	if($spamvalue								==			"1")
	{
		$spamvalue								=			"checked";
	}
	else
	{
		$spamvalue								=			"";
	}
	return $spamvalue;
}
// Bulk Spam
function commtouch_bulkspam()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$bulkvalue								=  			fread_stream('/var/qmail/control/','ctasd_onsession_out_block_bulk');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$bulkvalue								=  			getenvalfun('--outbound-bulk-reject');
	}
	if($bulkvalue								==			"1")
	{
		$bulkvalue								=			"checked";
	}
	else
	{
		$bulkvalue								=			"";
	}
	return $bulkvalue;
}
// Virus
function commtouch_virus()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$virusvalue								=  			fread_stream('/var/qmail/control/','ctasd_onsession_out_block_virus');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$virusvalue								=  			getenvalfun('--outbound-vod-virus-reject');
	}
	if($virusvalue								==			"1")
	{
		$virusvalue								=			"checked";
	}
	else
	{
		$virusvalue								=			"";
	}
	return $virusvalue;
}
// High Risk
function commtouch_highrisk()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$highriskvalue							=  			fread_stream('/var/qmail/control/','ctasd_onsession_out_block_vhigh');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$highriskvalue							=  			getenvalfun('--outbound-vod-high-reject');
	}
	if($highriskvalue							==			"1")
	{
		$highriskvalue							=			"checked";
	}
	else
	{
		$highriskvalue							=			"";
	}
	return $highriskvalue;
}
//Commtouch Total Spam
function commtouch_totalspam()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$totalspam								=			fread_stream('/var/qmail/control/','ctasd_onsession_out_totspam_num');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$totalspam								=  			getereadnvalfun('--spam-threshold');
		if($totalspam							==			"")
		{
			$totalspam							=  			getereadnvalfun('--spam-threshold');
		}
		
	}
		if($totalspam=="")
		{
			$totalspam=0;
		}
	return $totalspam;
}
//Commtouch Total Spam Action
function commtouch_totalspamaction()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$totalspamaction						=			fread_stream('/var/qmail/control/','ctasd_onsession_out_totspam_action');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$totalspamaction						=  			getereadnvalfun('--spam-threshold-action');
	}
	return $totalspamaction;
}
//Commtouch Total Suspected
function commtouch_totalsuspected()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$totalsuspected							=			fread_stream('/var/qmail/control/','ctasd_onsession_out_totsusp_num');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$totalsuspected							=  			getereadnvalfun('--suspected-threshold');
		if($totalsuspected						==			"")
		{
			$totalsuspected						=  			getereadnvalfun('--suspected-threshold');
		}
	}
			if($totalsuspected=="")
		{
			$totalsuspected=0;
		}
	return $totalsuspected;
}
//Commtouch Total Suspected Action
function commtouch_totalsuspectedaction()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$totalsuspectedaction					=			fread_stream('/var/qmail/control/','ctasd_onsession_out_totsusp_action');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$totalsuspectedaction					=  			getereadnvalfun('--suspected-threshold-action');
	}
	return $totalsuspectedaction;
}
//Commtouch Total Virus
function commtouch_totalvirus()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$totalvirus								=			fread_stream('/var/qmail/control/','ctasd_onsession_out_totvirus_num');

	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$totalvirus								=  			getereadnvalfun('--virus-threshold');
		if($totalvirus							==			"")
		{
			$totalvirus							=  			getereadnvalfun('--virus-threshold');
		}
	}
			if($totalvirus=="")
		{
		$totalvirus=0;
		}
	return $totalvirus;
}
//Commtouch Total Virus Action
function commtouch_totalvirusaction()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$totalvirusaction						=			fread_stream('/var/qmail/control/','ctasd_onsession_out_totvirus_action');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$totalvirusaction						=  			getereadnvalfun('--virus-threshold-action');
		
	}
	return $totalvirusaction;
}
//Commtouch Total Messages
function commtouch_totalmsgs()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$totalmsgs								=			fread_stream('/var/qmail/control/','ctasd_onsession_out_totmsgs_num');

	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$totalmsgs								=  			getereadnvalfun('--total-msgs-threshold');
		if($totalmsgs							==			"")
		{
			$totalmsgs							=  			getereadnvalfun('--total-msgs-threshold');
		}
	}
			if($totalmsgs=="")
		{
		$totalmsgs="0";
		}
	return $totalmsgs;
}
//Commtouch Total Messages Action
function commtouch_totalmsgsaction()
{
	$ctasdmailtype								=          mail_type();
	if($ctasdmailtype							==          "QMail")
	{
		$totalmsgsaction						=			fread_stream('/var/qmail/control/','ctasd_onsession_out_totmsgs_action');
	}
	else if($ctasdmailtype						==          "Postfix")
	{
		$totalmsgsaction						=  			getereadnvalfun('--total-msgs-threshold-action');
		
	}
	return $totalmsgsaction;
}
/*  Whitelistmanagement tab functions  */
function commtouch_whitelist()
{
	$white_list_value 							= 			fread_main_stream('/etc/ctasd/','senderid_white');
	$w_arr										= 			explode(",",$white_list_value);
	$white_list									=			"";
	foreach($w_arr as $option)
	if($option!="")
	{
		$option									=			trim($option);
		$white_list .="<option value='".$option."'>".$option."</option>";
	}
	return $white_list;
}
/*  Bluelistmanagement tab functions  */
function commtouch_bluelist()
{
	$blue_list_value 							= 			fread_main_stream('/etc/ctasd/','senderid_blue');
	$b_arr										= 			explode(",",$blue_list_value);
	$blue_list									=			"";
	foreach($b_arr as $option)
	if($option!="")
	{
		$option									=			trim($option);
		$blue_list .="<option value='".$option."'>".$option."</option>";
	}
	return $blue_list;
}
// --------------------- End reading values ---------------------------------

// --------------------- Start writing values ---------------------------------

//------------------trim function for post values--------------
function trim_value($data, $problem='')
{
	$data = trim($data);
	$data = stripslashes($data);
	$data = htmlspecialchars($data);
	return $data;
}
//-----------------------removing unwanted lines from ctasd.cof --------------------------------
function set_permission($filepath,$perm) // setting file permission
{
	$justback =system(PRODUCT_ROOT."/admin/bin/modules/".MODULE_NAME."/gtchown ".$filepath." ".$perm,$ret_type);
}
function crt_file($filepath,$ret_type) // setting file permission
{
	$justback =system(PRODUCT_ROOT."/admin/bin/modules/".MODULE_NAME."/ctasd_file ".$filepath." ".$ret_type);
}
function createconfpostfix($postfixvar, $postconffile)
{
	$filename=$postfixvar.$postconffile;
	if (file_exists($filename)) {
		crt_file($filename,"del");
	}
	crt_file($filename,"crt");
}
//....................................Editing ctasd-out.conf file..................
function fwrite_stream($fp, $fn, $stringData,$search_key) {
	$filepath		=		$fp.$fn;
	set_permission($filepath,"1");

	if(!($file_array			= 	file($filepath)))
	{return "Cannot open ".$filepath." file";}
	if(count($file_array)<=0)
	return "Invalid ".$filepath." file";
	foreach($file_array as $line)
	{
		if (strstr($line,$search_key))
		{
			$find= $line;
			break;
		}
	}
	$file_array2 = file_get_contents($filepath);
	$file_array = str_replace($find,$stringData,$file_array);
	if(!file_put_contents($filepath,$file_array)){
		return "Cannot write to ".$filepath." file";
	}
	set_permission($filepath,"0");
	return 1;
}
//....................................writing SenderIDHeaderName to ctasd-out.conf file..................
function fwrite_stream_headername($fp, $fn, $stringData) {
	$filepath		=		$fp.$fn;
	set_permission($filepath,"1");

	if(!($file_array			= 	file($filepath)))
	{return "Cannot open ".$filepath." file";}

	foreach($file_array as $line)
	{
		if (strstr($line,"SenderIDHeaderName")&& !strstr($line,"#SenderIDHeaderName:"))
		{
			$find= $line;
			break;
		}
	}


	$file_array = str_replace($find,$stringData,$file_array);
	if(!file_put_contents($filepath,$file_array)){
		return "Cannot write to ".$filepath." file";
	}
	set_permission($filepath,"0");
	return 1;
}
//-----------------------file write function --------------------------------
function fwrite_stream2($fp, $fn, $stringData) {
	$filepath		=		$fp.$fn;
	set_permission($filepath,"1");
	$fh 			= 		fopen($filepath, 'a') or die("can't open ".$filepath." file");
	fwrite($fh, $stringData);
	fclose($fh);
	set_permission($filepath,"0");
	return $fh;
}
//-----------------------file write function --------------------------------
function fwrite_stream1($fp, $fn, $stringData) {
	$filepath		=		$fp.$fn;
	if (!file_exists($filepath)) {
		crt_file($filepath,"crt");
	}
	set_permission($filepath,"1");
	$fh 			= 		fopen($filepath, 'w') or die("can't open ".$filepath." file");
	fclose($fh);
	$stringData .= "\n";
	file_put_contents($filepath,$stringData);
	set_permission($filepath,"0");
}

function fwrite_postfixstream($fp, $fn, $stringData, $pargument) {
	$filepath		=		$fp.$fn;
	if (!is_file($filepath)) {
		crt_file($filepath,"crt");
	}
	set_permission($filepath,"1");
	$file = $filepath;
	$fileHandle = fopen($file, 'a');
	if($stringData!="")
	{
		$data = $pargument." ".$stringData." ";
		$data1 = $pargument." ".$stringData;
	}
	else
	{
		$data = $pargument." ";
		$data1 = $pargument;
	}
	$lines = file($filepath);
	$fvalwrite=1;
	if(count($lines)>0)
	{
		foreach ($lines AS $line)
		{
			if (trim($line)==$data1)
			{
				$fvalwrite=0;
			}
		}
	}
	if($fvalwrite==1)
	{
		fwrite($fileHandle, $data);
	}
	fclose($fileHandle);
	set_permission($filepath,"0");
}
function fwrite_postfixstreammain($fp, $fn, $stringData, $pargument)
{
	$filepath		=		$fp.$fn;
	if (!file_exists($filepath)) {
		crt_file($filepath,"crt");
	}
	set_permission($filepath,"1");
	$file = $filepath;
	$fileHandle = fopen($file, 'a');
	if($stringData!="")
	{
		$data = $pargument." ".$stringData." ";
		$data1 = $pargument." ".$stringData;
	}
	else
	{
		$data = $pargument." ";
		$data1 = $pargument;
	}
	$lines = file($filepath);
	$fvalwrite=1;
	if(count($lines)>0)
	{
		foreach ($lines AS $line)
		{
			if (trim($line)==$data1)
			{
				$fvalwrite=0;
			}
		}
	}
	if($fvalwrite==1)
	{
		fwrite($fileHandle, $data."\n");
	}
	fclose($fileHandle);
	set_permission($filepath,"0");

}
function get_value_of($name)
{
	$lines = file('/etc/postfix/main.cf');
	foreach (array_values($lines) AS $line)
	{
		list($key, $val) = explode('=', trim($line) );
		if (trim($key) == $name)
		{
			return $val;
		}
	}
	return false;
}
function postfixaddtarg()
{
	$postfixvar 	=   "/opt/ctch/ct-milter/";
	$postconffile	=	"ct-milter.args";
	$mainval	 	=	preg_replace ("/,/","",preg_replace("/hash.*/","",trim(get_value_of('mynetworks'))));
	if(!empty($mainval))
	{
		$val1 		= 	explode(" ", $mainval);
		$result 	= 	count($val1);
		$pargument	=   "--local-networks $val1[0],$val1[2]";
		fwrite_postfixstream($postfixvar, $postconffile, '', $pargument);
	}
}
function fwrite_postfixreplace1($fp, $fn, $str, $strrp)
{
	$filepath		=		$fp.$fn;
	// open file to an array
	$fileLines = file($filepath);

	// loop through lines and look for search term
	$lineNumber = 1;
	foreach($fileLines as $line) {
		$searchCount = substr_count($line, $str);

		if($line==$str)
		{

			echo $line;
			exit;
		}
			

		$lineNumber++;
	}
}
function fwrite_postfixreplace($fp, $fn, $str, $strrp)
{
	$filepath		=		$fp.$fn;
	$file = file_get_contents($filepath);
	// replace the data
	$data = str_replace($str, $strrp, $file);
	// write the file
	set_permission($filepath,"1");
	$fileHandle = fopen($filepath, 'w');
	fwrite($fileHandle, $data);
	set_permission($filepath,"0");
}
function postfixmaincfwrite()
{
	$postfixmainfpath 				=			"/etc/postfix/";
	$postfixmainffile				= 			"main.cf";
	$pargument='milter_connect_macros = j {daemon_name} v';
	fwrite_postfixstreammain($postfixmainfpath, $postfixmainffile, '', $pargument);
	$pargument='milter_data_macros = i';
	fwrite_postfixstreammain($postfixmainfpath, $postfixmainffile, '', $pargument);
	$pargument='milter_end_of_data_macros = i';
	fwrite_postfixstreammain($postfixmainfpath, $postfixmainffile, '', $pargument);
	$pargument='milter_end_of_header_macros = i';
	fwrite_postfixstreammain($postfixmainfpath, $postfixmainffile, '', $pargument);
	$pargument='milter_helo_macros = {tls_version} {cipher} {cipher_bits} {cert_subject} {cert_issuer}';
	fwrite_postfixstreammain($postfixmainfpath, $postfixmainffile, '', $pargument);
	$pargument='milter_macro_daemon_name = $myhostname';
	fwrite_postfixstreammain($postfixmainfpath, $postfixmainffile, '', $pargument);
	$pargument='milter_macro_v = $mail_name $mail_version';
	fwrite_postfixstreammain($postfixmainfpath, $postfixmainffile, '', $pargument);
	$pargument='milter_mail_macros = i {auth_type} {auth_authen} {auth_author} {mail_addr}';
	fwrite_postfixstreammain($postfixmainfpath, $postfixmainffile, '', $pargument);
	$pargument='milter_rcpt_macros = i {rcpt_addr}';
	fwrite_postfixstreammain($postfixmainfpath, $postfixmainffile, '', $pargument);
}
function fwrite_ctpostfixstream($fp, $fn, $tv, $tvopt, $p1, $p2)
{
	$filepath		=		$fp.$fn;
	if($tvopt==1)
	{
		$data = $p1." ".$tv." ";
	}
	else if($tvopt==2)
	{
		$data = $p2." ".$tv." ";
	}
	set_permission($filepath,"1");
	$fileHandle = fopen($filepath, 'a');
	fwrite($fileHandle, $data);
	set_permission($filepath,"0");
}
//............................................function for writing bluelist and whitelist data to file...............................................
function fwrite_stream_list($fp, $fn, $stringData) {
	$filepath		=		$fp.$fn;
	crt_file($filepath,"crt");
	set_permission($filepath,"1");
	$fh 			= 		fopen($filepath, 'w') or die("can't open ".$filepath." file");
	fwrite($fh, $stringData);
	fclose($fh);
	set_permission($filepath,"0");
	return $fh;
}
function fwrite_postfixdelstream()
{

}
function fwrite_ctpostfixdelstream()
{

}
// --------------------- End writing values ---------------------------------
//------------------ form validation starts------
/*  Validate File path  */
function valid_filepath($filepath)
{
	$checker = new pm_Checker;
	return $checker->protectedDirName($filepath);
	//return $checker->filepath($filepath,"/","");

}
/*  Validate Server address  */
function validate_server($addr)
{
	$checker = new pm_Checker;
	$temp = str_replace("%","",$addr);
	if($checker->domain($temp))
	return true;
	else if($addr == "%")
	{   // check single % occurs
		return true;
	}
	else
	return false;
}
/*  Validate AScii code  */
function validate_custom($str)
{
	return (preg_match('/(?:[^\x00-\x7F])/',$str) !== 1);
}
//------------------ form validation ends

//......................... add to xml file
function fwrite_xml($file_root, $filename, $stringData) {
	$file = $file_root."/".$filename;
	if (!is_file($file)) {
	
		crt_file($file,"crt");
	}
	set_permission($file,"1");
	$fh 			= 		fopen($file, 'w');
	fwrite($fh, $stringData);
	fclose($fh);
	set_permission($file,"0");
	}
	
	// reading input mail file
	function init_graph($in_file, $period)
	{
	
	set_permission($in_file,"1");
	$mail = array();
	$mail["CONFIRMED_SPAM_".$period] = 0;
	$mail["BULK_SPAM_".$period] = 0;
	$mail["SUSPECTED_SPAM_".$period] = 0;
	$mail["UNKNOWN_SPAM_".$period] = 0;
	$mail["NON_SPAM_".$period] = 0;	
	$mail['VIRUS_'.$period] = 0;
	$mail['HIGH_'.$period] = 0;
	$i=1;
	if(is_file($in_file))
	{
	set_permission($in_file,"1");
	
	if( $fh 			= 		fopen($in_file, 'r'))
	{
	//$spam_var = array('SUSPECTED_SPAM','UNKNOWN_SPAM','NON_SPAM','VALID_BULK','CONFIRMED_SPAM','BULK_SPAM');
	
	while(!feof($fh) && $i<=50)
	{
	$line = fgets($fh);
	
	 $array1 = explode(",",$line);
	 if(count($array1)>1)
	{
	
	$name = $array1[0];
	
	if($array1[0] == "Spam")
	{
	$mail["CONFIRMED_SPAM_".$period] = is_numeric(trim($array1[5]))?trim($array1[5]):0;
	$mail["BULK_SPAM_".$period] = is_numeric(trim($array1[4]))?trim($array1[4]):0;
	$mail["SUSPECTED_SPAM_".$period] = is_numeric(trim($array1[3]))?trim($array1[3]):0;
	$mail["UNKNOWN_SPAM_".$period] = is_numeric(trim($array1[2]))?trim($array1[2]):0;
	$mail["NON_SPAM_".$period] = is_numeric(trim($array1[1]))?trim($array1[1]):0;
	}
	else if($array1[0] == "Virus")
	{
	$mail['VIRUS_'.$period] = is_numeric(trim($array1[4]))?trim($array1[4]):0;
	$mail['HIGH_'.$period] = is_numeric(trim($array1[5]))?trim($array1[5]):0;
	}
	else
	{
	
	$mail['SENDER_ID_'.$period."".$i] 		= 	trim($array1[0]);
	$mail['TOTAL_SPAM_'.$period."".$i] 		= 	is_numeric(trim($array1[1]))?number_format(trim($array1[1])):0;
	$mail['TOTAL_VIRUS_'.$period."".$i] 	= 	is_numeric(trim($array1[2]))?number_format(trim($array1[2])):0;
	$mail['TOTAL_MESSAGES_'.$period."".$i] 	= 	is_numeric(trim($array1[3]))?number_format(trim($array1[3])):0;
	$i++;
	}

	}
	}
	
 }
 }
 	$mail['count_'.$period] = $i-1;
	$msg_blocked = $mail["CONFIRMED_SPAM_".$period] + $mail["BULK_SPAM_".$period];
	$mail['TOT_VALID_MAIL_'.$period] =  number_format($mail["SUSPECTED_SPAM_".$period] + $mail["UNKNOWN_SPAM_".$period] + $mail["NON_SPAM_".$period]);
	$mail['TOT_SPAM_MAIL_'.$period] =  number_format($mail["CONFIRMED_SPAM_".$period] + $mail["BULK_SPAM_".$period]) ;
	$mail['TOT_MESSAGES_'.$period] = number_format($mail["SUSPECTED_SPAM_".$period] + $mail["UNKNOWN_SPAM_".$period] + $mail["NON_SPAM_".$period] + $mail["CONFIRMED_SPAM_".$period] + $mail["BULK_SPAM_".$period]);
   $msg_total = $mail["SUSPECTED_SPAM_".$period] + $mail["UNKNOWN_SPAM_".$period] + $mail["NON_SPAM_".$period] + $mail["CONFIRMED_SPAM_".$period] + $mail["BULK_SPAM_".$period];
	 if($mail['TOT_MESSAGES_'.$period] != 0)
	 {
	$mail['SPAM_CATCH_RATE_'.$period] = round(($msg_blocked/$msg_total)*100);
	}
	else
	{
	$mail['SPAM_CATCH_RATE_'.$period]=0;
	}
	$mail['TOT_VIRUS_'.$period] = number_format($mail['VIRUS_'.$period] + $mail['HIGH_'.$period]);
	
	return $mail;

	}
	// function to check the status of the outbound spam protection service
	function service_status() {
	    $ctasdmailtype	=   mail_type();
	    if($ctasdmailtype == "QMail") {
		if(is_file("/var/run/ctasd/ctasd.pid"))
		    return true;
		else
	    return false;
	    } else if($ctasdmailtype == "Postfix") {
		if(is_file("/var/run/ctasd/ctasd.pid") && is_file("/var/run/ctmilter/ctmilter"))
		    return true;
		else
		    return false;
	    }
	}
	function check_services_status()
	{ $file1 = "/tmp/qctasdcheck";
			
			if (!is_file($file1)) {
			crt_file($file1,"crt");
			}
			$ret_type= array();
			set_permission($file1,"1");			
			exec(PRODUCT_ROOT."/admin/bin/modules/".MODULE_NAME."/postoutset checkq", $ret_type);
			$str = file_get_contents($file1);			
			set_permission($file1,"0");
			$ctasdmailtype								=          mail_type();
		if($ctasdmailtype == "QMail")
		{
			if(stristr($str,"yes"))
			return true;
			else
			return false;
		}
		else if($ctasdmailtype == "Postfix")
		{
		$file2 = "/tmp/pctasdcheck";
		if (!is_file($file2)) {
			crt_file($file2,"crt");
			}
			$ret_type2= array();
			set_permission($file2,"1");
			exec(PRODUCT_ROOT."/admin/bin/modules/".MODULE_NAME."/postoutset checkp", $ret_type2);
			$str2 =  file_get_contents($file2);
			set_permission($file2,"0");
			if(stristr($str,"yes")&& stristr($str2,"yes"))
			return true;
			else
			return false;
		}
	}
	

?>